(* eager_v_lazy.ml: show the difference between eager and lazy
   evaluation models in OCaml through the use of keyword "lazy" and
   Lazy.force. *)

open Printf;;

printf "Eager Eval\n";;

let print_it expr =
  printf "Printing it\n";
  printf "%d\n" expr;                       (* already evaluated *)
;;

print_it (begin                             (* pass a normal expression *)
            printf "Evaluating\n";          (* which will be eval'd  *)
            5;                              (* before the call *)
          end);;

printf "Lazy Eval\n";;

let print_it_lazy expr =
  printf "Printing it\n";
  printf "%d\n" (Lazy.force expr);          (* force required to eval *)
;;

print_it_lazy (lazy (begin                  (* pass a lazy expression *)
                       printf "Evaluating\n";
                       5;
                     end));;
